#ifndef gmlib_h
#define gmlib_h

#include <winlib.h>

#define GM_EVENT 0x676d6576	// "gmev"

#define GMO_INITIALIZE 0x0000
#define GMO_CLICK 0x0001
#define GMO_MOVE 0x0002
#define GMO_REPEAT 0x0003
#define GMO_RELEASE 0x0004
#define GM_CLICK 0x0100
#define GM_MOVETOFRONT 0x0101
// enum ObjectActions {GMO_INITIALIZE=0x0000};


#define BEGIN_GUI_SECTION(name) ListElementHeader name = {NULL, 0, 0, 0};

typedef struct {
  int signature;
  int id;
  SCR_RECT area;
  union {
    WORD all;
    struct {
      unsigned int trig_click : 1;
      unsigned int trig_repeat : 1;
      unsigned int trig_move : 1;
      unsigned int trig_release : 1;
      unsigned int repeatdelay : 4;
      unsigned int obj : 8;
    } bits;
  } flags;
} GMO_HEADER;

#define GMO_HEADER_SIZE 8
#define GMO_FLAGS_SIZE 2
#define GMO_HEADER_I \
  int signature; \
  int id; \
  SCR_RECT area

#define TRIG_CLICK 0x80
#define TRIG_REPEAT 0x40
#define TRIG_MOVE 0x20
#define TRIG_RELEASE 0x10
#define TRIG_REPEAT_DELAY 0x0f

#define TEXT_HORIZONTAL_LEFT 0x00
#define TEXT_HORIZONTAL_RIGHT 0x10
#define TEXT_HORIZONTAL_CENTERED 0x20
#define TEXT_VERTICAL_TOP 0x00
#define TEXT_VERTICAL_BOTTOM 0x40
#define TEXT_VERTICAL_CENTERED 0x80

#define TEXT_LEFT_TOP TEXT_HORIZONTAL_LEFT+TEXT_VERTICAL_TOP
#define TEXT_RIGHT_TOP TEXT_HORIZONTAL_RIGHT+TEXT_VERTICAL_TOP
#define TEXT_CENTER_TOP TEXT_HORIZONTAL_CENTERED+TEXT_VERTICAL_TOP
#define TEXT_LEFT_BOTTOM TEXT_HORIZONTAL_LEFT+TEXT_VERTICAL_BOTTOM
#define TEXT_RIGHT_BOTTOM TEXT_HORIZONTAL_RIGHT+TEXT_VERTICAL_BOTTOM
#define TEXT_CENTER_BOTTOM TEXT_HORIZONTAL_CENTERED+TEXT_VERTICAL_BOTTOM
#define TEXT_LEFT_CENTER TEXT_HORIZONTAL_LEFT+TEXT_VERTICAL_CENTERED
#define TEXT_RIGHT_CENTER TEXT_HORIZONTAL_RIGHT+TEXT_VERTICAL_CENTERED
#define TEXT_CENTER_CENTER TEXT_HORIZONTAL_CENTERED+TEXT_VERTICAL_CENTERED

#define ADD_TEXTBUTTON(label,id,x0,y0,x1,y1,sysflags,objflags,attr,font,str) GMO_TEXTBUTTON label = {GUI_TEXTBUTTON, id, {x0,y0,x1,y1}, (sysflags << 8) + objflags, attr, font, str};
#define GUI_TEXTBUTTON 0x01
#define GMO_TEXTBUTTON_SIZE GMO_HEADER_SIZE+GMO_FLAGS_SIZE+6
typedef struct {
  GMO_HEADER_I;
  union {
    WORD all;
    struct {
      unsigned int trig_click : 1;
      unsigned int trig_repeat : 1;
      unsigned int trig_move : 1;
      unsigned int trig_release : 1;
      unsigned int repeatdelay : 4;
      unsigned int vertical_centered : 1;    // 0x80
      unsigned int vertical_position : 1;    // 0x40
      unsigned int horizontal_centered : 1;  // 0x20
      unsigned int horizontal_position : 1;  // 0x10
      unsigned int edge : 4;
    } bits;
  } flags;
  BYTE attr;
  BYTE font;
  char *str;
} GMO_TEXTBUTTON;

#define ADD_TEXT(label,id,x0,y0,x1,y1,sysflags,objflags,attr,font,str) GMO_TEXT label = {GUI_TEXT, id, {x0,y0,x1,y1}, (sysflags << 8) + objflags, attr, font, str};
#define GUI_TEXT 0x00
#define GMO_TEXT_SIZE GMO_HEADER_SIZE+GMO_FLAGS_SIZE+6
typedef struct {
  GMO_HEADER_I;
  union {
    WORD all;
    struct {
      unsigned int trig_click : 1;
      unsigned int trig_repeat : 1;
      unsigned int trig_move : 1;
      unsigned int trig_release : 1;
      unsigned int repeatdelay : 4;
      unsigned int vertical_centered : 1;
      unsigned int vertical_position : 1;
      unsigned int horizontal_centered : 1;
      unsigned int horizontal_position : 1;
      unsigned int edge : 4;
    } bits;
  } flags;
  BYTE attr;
  BYTE font;
  char *str;
} GMO_TEXT;

#define ADD_SCROLLBAR(label,id,x0,y0,x1,y1,sysflags,objflags,virtualwidth,realwidth,init) GMO_SCROLLBAR label = {GUI_SCROLLBAR, id, {x0,y0,x1,y1}, (sysflags << 8) + objflags, virtualwidth, realwidth, init};
#define GUI_SCROLLBAR 0x02
#define GMO_SCROLLBAR_SIZE GMO_HEADER_SIZE+GMO_FLAGS_SIZE+6
typedef struct {
  GMO_HEADER_I;
  union {
    WORD all;
    struct {
      unsigned int trig_click : 1;
      unsigned int trig_repeat : 1;
      unsigned int trig_move : 1;
      unsigned int trig_release : 1;
      unsigned int repeatdelay : 4;
      unsigned int obj : 5;
      unsigned int horizontal : 1;
      unsigned int arrows_aside : 1;
      unsigned int arrows_position: 1;
    } bits;
  } flags;
  int virtualwidth, realwidth, current;
} GMO_SCROLLBAR;
#define VERTICAL 0x00
#define HORIZONTAL 0x04
#define NO_ARROWS 0x00
#define ARROWS_SIDES 0x01
#define ARROWS_SIDE1 0x02
#define ARROWS_SIDE2 0x03


#define ADD_LIST(label,id,x0,y0,x1,y1,sysflags,objflags,font,first,size,selected,items) GMO_LIST label = {GUI_LIST, id, {x0,y0,x1,y1}, (sysflags << 8) + objflags, font,first,size,selected,items};
#define GUI_LIST 0x03
#define GMO_LIST_SIZE GMO_HEADER_SIZE+GMO_FLAGS_SIZE+8
typedef struct {
  GMO_HEADER_I;
  union {
    WORD all;
    struct {
      unsigned int trig_click : 1;
      unsigned int trig_repeat : 1;
      unsigned int trig_move : 1;
      unsigned int trig_release : 1;
      unsigned int repeatdelay : 4;
      unsigned int obj : 5;
      unsigned int scrollbar_position : 1;
      unsigned int arrows_aside : 1;
      unsigned int arrows_position: 1;
    } bits;
  } flags;
  BYTE font,size,first,selected;
  void *items;
} GMO_LIST;
#define SCROLLBAR_LEFT 0x00
#define SCROLLBAR_RIGHT 0x04
#define NO_ARROWS 0x00
#define ARROWS_SIDES 0x01
#define ARROWS_SIDE1 0x02
#define ARROWS_SIDE2 0x03

#define END_GUI_SECTION(name) int name##End = -1;

/*
typedef struct {
  EventClickStruct *e;
  GMO_HEADER *o;
} GM_EventClickStruct;
*/

//
// Global flags, should be recognised (or ignored/redefined) by all objects.
//





// Prosit header additions.
#define GMLIB_HANDLER 0x0801
#define DEFINE_GMLIB_HANDLER(function) asm(".word "##XSTR(GMLIB_HANDLER)##"\n .long " ## #function);

typedef struct {
  PrositHeaderElement_Header header;
  void *code;
} PrositHeaderElement_GMLibHandler;


// ************* Exported functions **************

#define GM_DrawStructure gmlib__0000
void GM_DrawStructure(PWINDOW *w, ListHeader *list);

#define GM_DrawGroup winlib__0001
void GM_DrawStructureGroup(PWINDOW *w, ListElementHeader *g);

#define GM_DrawStructureObject gmlib__0002
void GM_DrawStructureObject(PWINDOW *w, void *o);

#define GM_InitializeWindow gmlib__0003
void GM_InitializeWindow(PWINDOW *w);

#define GM_Click gmlib__0004
void GM_Click(EventClickStruct *e);
//void GM_Click(PWINDOW *w, WIN_POINT xy);

#define GM_Draw3DBox gmlib_0005
void GM_Draw3DBox(PWINDOW *w, SCR_RECT *r, BYTE attr);

#define GM_DrawFilledRect gmlib_0006
void GM_DrawFilledRect(PWINDOW *w, SCR_RECT *r, BYTE color);

#endif
