#define TI92PLUS
//#define TI89

#include <romcalls.h>
#include <prosit.h>
#include <winlib.h>
#include <gmlib.h>



int _library;

#define SCROLLER_MINWIDTH 4

// Variables for TextButton
BOOL inside;

// Variables for Scroller
ULONG scrollerbuttontext;
SCR_COORDS realstart,*real;
SCR_RECT dragbar;
int barwidth,ratio,selectedButtonAdd;
GMO_TEXTBUTTON decButton, incButton, *selectedButton;

// Variables for List
GMO_SCROLLBAR listScrollbar;
int visible_items, item_width, item_x, scrollbarSelected;
WIN_RECT listarea;

//
// TEXT - label,id,sysflags,objflags,x0,y0,x1,y1,attr,font,str
//
void Text(EventClickStruct *e, GMO_TEXT *o)
{
  if(e->action == GMO_INITIALIZE) {
    int x,y;
    WIN_RECT box = {o->area.xy.x0, o->area.xy.y0, o->area.xy.x1, o->area.xy.y1};

    if(o->flags.bits.horizontal_centered) {
      x = ((int)(o->area.xy.x1) + (int)(o->area.xy.x0) - DrawStrWidth(o->str, o->font))/2;
    }
    else {
      if(o->flags.bits.horizontal_position)
        x = (int)(o->area.xy.x1) - (int)o->flags.bits.edge - DrawStrWidth(o->str, o->font);
      else
        x = (int)(o->area.xy.x0) + (int)o->flags.bits.edge;
    }

    if(o->flags.bits.vertical_centered) {
      y = ((int)(o->area.xy.y1) + (int)(o->area.xy.y0))/2 - 2 - o->font;
    }
    else {
      if(o->flags.bits.horizontal_position)
        y = (int)(o->area.xy.y1) - 4 - 2*o->font - (int)o->flags.bits.edge;
      else
        y = (int)(o->area.xy.y0) + (int)o->flags.bits.edge;
    }

    WinFont(&e->w->Win, o->font);
    e->w->Win.CurAttr = o->attr;
    e->w->Win.DupScr = e->w->ContentsHandle[0];
    WinFill(&e->w->Win, &box, A_NORMAL - (o->attr & A_NORMAL));
    WinStrXY(&e->w->Win, x, y, o->str);
  }
}

//
// TEXTBUTTON - label,id,sysflags,objflags,x0,y0,x1,y1,attr,font,str
//
void TextButton(EventClickStruct *e, GMO_TEXTBUTTON *o)
{
//  static BOOL inside;
  BOOL newinside;

  switch(e->action) {
  case GMO_INITIALIZE:
    Text(e,(GMO_TEXT *)o);
    GM_Draw3DBox(e->w, &o->area, A_NORMAL);
    break;
  case GMO_CLICK:
    inside = TRUE;
    if((e->w->handler) && (o->flags.bits.trig_click))
      e->w->handler(e);
    GM_Draw3DBox(e->w, &o->area, A_REVERSE);
    PWinRefresh(e->w);
    break;
  case GMO_REPEAT:
    if((e->w->handler) && (o->flags.bits.trig_repeat) && inside)
      e->w->handler(e);
    break;
  case GMO_MOVE:
    if((newinside = MouseInside(e->w, &o->area)) != inside) {
      inside = newinside;
      GM_Draw3DBox(e->w, &o->area, A_NORMAL - inside);
      PWinRefresh(e->w);
    }
    break;
  case GMO_RELEASE:
    GM_Draw3DBox(e->w, &o->area, A_NORMAL);
    PWinRefresh(e->w);
    if((e->w->handler) && (o->flags.bits.trig_release) && inside)
      e->w->handler(e);
    break;
  }
}

//
// SCROLLER - label,id,sysflags,objflags,x0,y0,x1,y1,vwidth,rwidth,current
//

void Scrollbar(EventClickStruct *e, GMO_SCROLLBAR *o)
{
  int newvalue = o->current;

  // If GMO_INITIALIZE or GMO_CLICK, calculate what's needed.
  if((e->action == GMO_INITIALIZE) || (e->action == GMO_CLICK)) {
    SCR_COORDS *xref,*yref,bmxv,bmyv,bpxv,bpyv,bsize;
    SCR_COORDS *bmx,*bpx,*bmy,*bpy;
    int scrollerwidth;

    bmxv = bpxv = o->area.xy.x0+1;
    bmyv = bpyv = o->area.xy.y0+1;

    if(o->flags.bits.horizontal) {
      bmx=&bmxv;
      bpx=&bpxv;
      bmy=&bmyv;
      bpy=&bpyv;

      xref = &o->area.xy.x0;
      yref = &o->area.xy.y0;

      real = &dragbar.xy.x0;

      scrollerbuttontext = 0x11001200;
      dragbar = (SCR_RECT){0, o->area.xy.y0+1, 0, o->area.xy.y1-1};
    }
    else {
      bmx=&bmyv;
      bpx=&bpyv;
      bmy=&bmxv;
      bpy=&bpxv;

      xref = &o->area.xy.y0;
      yref = &o->area.xy.x0;

      real = &dragbar.xy.y0;

      scrollerbuttontext = 0x13001400;
      dragbar = (SCR_RECT){o->area.xy.x0+1, 0, o->area.xy.x1-1, 0};
    }

    realstart = *(xref)+1;
    bsize = *(yref+2) - *(yref) - 1;
    scrollerwidth = *(xref+2) - realstart - 2*bsize;

    if(o->flags.bits.arrows_aside || o->flags.bits.arrows_position) {
      if(o->flags.bits.arrows_aside) {
        if(o->flags.bits.arrows_position) {
          *bmx = *(xref+2)-2*bsize;
        }
        else {
          *bmx = *(xref)+1;
          realstart += 2*bsize;
        }
        *bpx = *bmx + bsize;
      }
      else {
        *bmx = *(xref)+1;
        *bpx = *(xref+2)-bsize;
        realstart += bsize;
      }
      decButton = (GMO_TEXTBUTTON){GUI_TEXTBUTTON,o->id,{bmxv,bmyv,bmxv+bsize-1,bmyv+bsize-1},(o->flags.all & 0xff00)+TEXT_CENTER_CENTER,A_NORMAL,F_4x6,(char *)&scrollerbuttontext};
      incButton = (GMO_TEXTBUTTON){GUI_TEXTBUTTON,o->id,{bpxv,bpyv,bpxv+bsize-1,bpyv+bsize-1},(o->flags.all & 0xff00)+TEXT_CENTER_CENTER,A_NORMAL,F_4x6,(char *)&scrollerbuttontext+2};
    }
    else {
      decButton.signature = incButton.signature = NULL;
      scrollerwidth += 2*bsize;
    }

    ratio = (scrollerwidth << 8) / o->virtualwidth;

    if((barwidth = (ratio  * o->realwidth)) < 256*SCROLLER_MINWIDTH) {
      ratio -= (256*SCROLLER_MINWIDTH - barwidth) / o->virtualwidth;
      barwidth = 256*SCROLLER_MINWIDTH;
    }

  }

  // If GMO_INITIALIZE, draw everything, including containBox and the buttons (if used).
  if(e->action == GMO_INITIALIZE) {
    *real = realstart + ((ratio * o->current) >> 8);
    *(real+2) = *real + (barwidth >> 8) - 1;
    GM_Draw3DBox(e->w, &o->area, A_REVERSE);
    GM_Draw3DBox(e->w, &dragbar, A_NORMAL);
    if(decButton.signature) {
      TextButton(e, &decButton);
      TextButton(e, &incButton);
    }
  }
  else {
    if(e->action == GMO_CLICK) {
      if((decButton.signature) && MouseInside(e->w, &(selectedButton = &decButton)->area)) {
        selectedButtonAdd = -1;
      }
      else if((decButton.signature) && MouseInside(e->w, &(selectedButton = &incButton)->area)) {
        selectedButtonAdd = 1;
      }
      else if(MouseInside(e->w, &o->area)) {
        selectedButtonAdd = 2;
      }
      else {
        selectedButtonAdd = 0;
      }
    }

    // Calculate the scrollbar's new value.
    if(selectedButtonAdd & 0x0001) {
      if(((e->action == GMO_CLICK) || (e->action == GMO_REPEAT)) && inside)
        newvalue = o->current + selectedButtonAdd;
    }
    else if(selectedButtonAdd && ((e->action == GMO_CLICK) || (e->action == GMO_MOVE))) {
      if(o->flags.bits.horizontal)
        newvalue = (((e->xy.x0 - realstart)*256)) / ratio;
      else
        newvalue = (((e->xy.y0 - realstart)*256)) / ratio;
    }

    // Check new value's boundaries.
    if(newvalue < 0)
      newvalue = 0;
    if(newvalue > o->virtualwidth - o->realwidth)
      newvalue = o->virtualwidth - o->realwidth;

    // Redraw the dragbar if it has moved.
    if((newvalue != o->current) && (newvalue >= 0) && (newvalue <= o->virtualwidth - o->realwidth)) {
      *real = realstart + ((ratio * o->current) >> 8);
      *(real+2) = *real + (barwidth >> 8) - 1;
      GM_DrawFilledRect(e->w, &dragbar, 0x01);
      o->current = newvalue;
      *real = realstart + ((ratio * o->current) >> 8);
      *(real+2) = *real + (barwidth >> 8) - 1;
      GM_Draw3DBox(e->w, &dragbar, A_NORMAL);
      PWinRefresh(e->w);
    }

    if(selectedButtonAdd & 0x0001) {
      TextButton(e, selectedButton);
    }
    else if(selectedButtonAdd) {
      if((e->w->handler) && (((o->flags.bits.trig_click) && (e->action == GMO_CLICK)) ||
                             ((o->flags.bits.trig_move) && (e->action == GMO_MOVE)) ||
                             ((o->flags.bits.trig_release) && (e->action == GMO_RELEASE))))
        e->w->handler(e);
    }
  }
}


//
// LIST - label,id,sysflags,objflags,x0,y0,x1,y1,*items,first,selected
//
void ListDraw(EventClickStruct *e, GMO_LIST *o) {
  int i;
  WIN_RECT textarea = listarea;

  WinFont(&e->w->Win,o->font);
  e->w->Win.CurAttr = A_NORMAL;
  e->w->Win.DupScr = e->w->ContentsHandle[0];

  WinFill(&e->w->Win, &listarea, A_REVERSE);

  for(i=0 ; i<visible_items ; i++) {
    WinStrXY(&e->w->Win, item_x, o->area.xy.y0+1+1+(6+2*o->font)*i, (char *)*(ULONG *)(o->items + 4*(o->first + i)));
    if((o->first + i) == o->selected) {
      textarea.y0 = o->area.xy.y0+1+1+(6+2*o->font)*i;
      textarea.y1 = textarea.y0 + (5+2*o->font);
      WinFill(&e->w->Win, &textarea, A_XOR);
    }
  }
}

void List(EventClickStruct *e, GMO_LIST *o)
{
  // If GMO_INITIALIZE or GMO_CLICK, calculate what's needed.
  if((e->action == GMO_INITIALIZE) || (e->action == GMO_CLICK)) {
    SCR_RECT containBox = o->area;
    visible_items = (o->area.xy.y1 - o->area.xy.y0 - 1 - 1) / (6 + 2*o->font);

    if(visible_items < o->size) {
      int sx;
      if(o->flags.bits.scrollbar_position) {
        sx = o->area.xy.x1-8;
        containBox.xy.x1 -= 9;
      }
      else {
        sx = o->area.xy.x0;
        containBox.xy.x0 += 9;
      }
      item_x = containBox.xy.x0+1;
      listarea = (WIN_RECT){item_x,containBox.xy.y0+1,containBox.xy.x1-1,containBox.xy.y1-1};
      listScrollbar = (GMO_SCROLLBAR){GUI_SCROLLBAR,o->id,{sx,containBox.xy.y0,sx+8,containBox.xy.y1},(o->flags.all & 0xff03)+TEXT_CENTER_CENTER,o->size,visible_items,o->first};
      item_width = containBox.xy.x1 - containBox.xy.x0 - 1;
    }
    else {
      listScrollbar.signature = NULL;
    }  

    // If GMO_INITIALIZE, draw everything, including containBox and the scrollbar (if used).
    if(e->action == GMO_INITIALIZE) {
      GM_Draw3DBox(e->w, &containBox, A_REVERSE);
      if(listScrollbar.signature) {
        listScrollbar.current = o->first;
        Scrollbar(e, &listScrollbar);
      }

      ListDraw(e,o);
    } 
    else {
      if(e->action == GMO_CLICK)
        scrollbarSelected = ((listScrollbar.signature) && MouseInside(e->w, &listScrollbar.area));
    }
  }

  if(scrollbarSelected) {
    Scrollbar(e, &listScrollbar);
    if(listScrollbar.current != o->first) {
      o->first = listScrollbar.current;
      ListDraw(e,o);
      PWinRefresh(e->w);
    }
  }
  else if(e->action == GMO_CLICK) {
    int newvalue = o->first + (e->xy.y0 - listarea.y0) / (6+2*o->font);
    if((newvalue >= o->first) && (newvalue < o->size) && (o->selected != newvalue)) {
      o->selected = newvalue;
      ListDraw(e,o);
      PWinRefresh(e->w);
    }
  }
}

// *************************************************************
//  Pointers for virtual functions that handle the GUI objects.
// *************************************************************
struct {
  BOOL (*function) (EventClickStruct *e, void *o);
  WORD datasize;
} GM_FUNCTIONS[] = 
{{(void *)&Text, GMO_TEXT_SIZE},
 {(void *)&TextButton, GMO_TEXTBUTTON_SIZE},
 {(void *)&Scrollbar, GMO_SCROLLBAR_SIZE},
 {(void *)&List, GMO_LIST_SIZE}};

// *************************************************************


void GM_Draw3DBox(PWINDOW *w, SCR_RECT *r, BYTE attr)
{
  int i;
  WIN_RECT box = {r->xy.x0, r->xy.y0, r->xy.x1, r->xy.y1}, line1 = box, line2 = box;

  line1.x1 = r->xy.x0;
  line2.y1 = r->xy.y0;

  w->Win.CurAttr = 1-attr;

  for(i=0 ; i<=1 ; i++) {
    w->Win.DupScr = w->ContentsHandle[i];
    WinRect(&w->Win, &box, attr);
    WinLine(&w->Win, &line1);
    WinLine(&w->Win, &line2);
  }
}

void GM_DrawFilledRect(PWINDOW *w, SCR_RECT *r, BYTE color)
{
  WIN_RECT box = {r->xy.x0, r->xy.y0, r->xy.x1, r->xy.y1};

  w->Win.DupScr = w->ContentsHandle[0];
  WinFill(&w->Win, &box, (color & 0x02) >> 1);
  w->Win.DupScr = w->ContentsHandle[1];
  WinFill(&w->Win, &box, color & 0x01);
}

void GM_DrawStructureObject(PWINDOW *w, void *o)
{
  HANDLE OldPlane = w->Win.DupScr;
  BYTE OldAttrs = w->Win.CurAttr, OldFont = w->Win.CurFont;
  EventClickStruct e = {GMO_INITIALIZE,0,w,0};

  GM_FUNCTIONS[((GMO_HEADER *)o)->signature].function(&e, o);

  w->Win.DupScr = OldPlane;
  w->Win.CurAttr = OldAttrs;
  WinFont(&w->Win, OldFont);
}

void GM_DrawStructureGroup(PWINDOW *w, ListElementHeader *g)
{
  GMO_HEADER *o = (void *)g + 8;
  while(o->signature >= 0) {
    GM_DrawStructureObject(w, o);
    o = (void *)o + GM_FUNCTIONS[((GMO_HEADER *)o)->signature].datasize;
  }
}

void GM_DrawStructure(PWINDOW *w, ListHeader *list)
{
  ListElementHeader *current;

  if(current = list->first)
    do {
      GM_DrawStructureGroup(w, current);
      current = current->next;
    } while(current != list->first);
}

void GM_InitializeWindow(PWINDOW *w)
{
  if(w->Win.Flags.all & PWF_USES_GMLIB) {
    GM_DrawStructure(w, &w->StructureList);
    PWinRefresh(w);
  }
}

void GM_Click(EventClickStruct *e)
// void GM_Click(PWINDOW *w, WIN_POINT xy)
{
  ListElementHeader *current;
  void *header;
  PrositHeaderElement_GMLibHandler *field;

  if(e->w->Win.Flags.all & (PWF_USES_GMLIB+PWF_ACTIVE)) {
    if(e->w->handler) {
      e->action = GM_CLICK;
      e->w->handler(e);
    }

    if(current = e->w->StructureList.first) {
      GMO_HEADER *o;
      do {
        o = (void *)current + 8;
        while((o->signature >= 0) && (!MouseInside(e->w, &o->area)))
          o = (void *)o + GM_FUNCTIONS[o->signature].datasize;

        // If we are over an object, deal with it.
        if(o->signature >= 0) {
          HANDLE OldPlane = e->w->Win.DupScr;
          BYTE OldAttrs = e->w->Win.CurAttr, OldFont = e->w->Win.CurFont;
          int OldMouseX = MouseX, OldMouseY = MouseY;
          ULONG myTick = 0;

          e->id = o->id;

          if(o->flags.bits.trig_click) {
            myTick = Ticks + (((1 + o->flags.bits.repeatdelay) << 3) << 2);
          }
          else {
            myTick = Ticks + ((1 + o->flags.bits.repeatdelay) << 3);
          }

          e->action = GMO_CLICK;
          GM_FUNCTIONS[o->signature].function(e,o);

          while(!MOUSEKEY) {
            if((o->flags.bits.trig_repeat) && (Ticks >= myTick)) {
              e->action = GMO_REPEAT;
              GM_FUNCTIONS[o->signature].function(e,o);
              myTick = Ticks + ((1 + o->flags.bits.repeatdelay) << 3);
            }
            if((MouseX != OldMouseX) || (MouseY != OldMouseY)) {
              OldMouseX = MouseX;
              OldMouseY = MouseY;
              e->xy.x0 = MouseX - e->w->X;
              e->xy.y0 = MouseY - e->w->Y;
              e->action = GMO_MOVE;
              GM_FUNCTIONS[o->signature].function(e,o);
            }
            BreakAndCooperate();
          }

          e->action = GMO_RELEASE;
          GM_FUNCTIONS[o->signature].function(e,o);

          e->w->Win.DupScr = OldPlane;
          e->w->Win.CurAttr = OldAttrs;
          WinFont(&e->w->Win, OldFont);
        }

      } while(current != e->w->StructureList.first);
    }
  }
}
