#define TI92PLUS
//#define TI89

#include <romcalls.h>
#include <prosit.h>
#include <winlib.h>
#include <wmlib.h>
#include <gmlib.h>
#include <shrnklib.h>

#define WIN_X 2
#define WIN_Y 9
#define WIN_WIDTH 59
#define WIN_HEIGHT 76
#define WIN_FLAGS PWF_USES_GMLIB+PWF_USES_WMLIB+PWF_ACTIVE+PWF_MOVEABLE

#define WIN2_X 0
#define WIN2_Y LCD_HEIGHT-9
#define WIN2_WIDTH 18
#define WIN2_HEIGHT 9
#define WIN2_FLAGS PWF_USES_WMLIB+PWF_USES_GMLIB+PWF_ACTIVE+PWF_NOBORDER

BOOL Running;

// ********************* Constants *********************

/*
1000000000000000
1100000000000000
1010000000000000
1001000000000000

1000100000000000
1000010000000000
1000001000000000
1000000100000000

1000000010000000
1000001100000000
1000110000000000
1011000000000000

1100000000000000
0000000000000000
0000000000000000
0000000000000000
*/
MOUSEPOINTER MyMousePointer = {9, 13, 1, 1,
 {{0x8000, 0xc000, 0xa000, 0xb000, 0x9800, 0x8c00, 0x8600, 0x8300,
   0x8180, 0x8700, 0x9c00, 0xb000, 0xc000, 0x0000, 0x0000, 0x0000},
  {0x8000, 0xc000, 0xa000, 0xb000, 0xb800, 0xbc00, 0xbe00, 0xbf00,
   0xbf80, 0xbf00, 0xbc00, 0xb000, 0xc000, 0x0000, 0x0000, 0x0000}},
  {0x8000, 0xc000, 0xe000, 0xf000, 0xf800, 0xfc00, 0xfe00, 0xff00,
   0xff80, 0xff00, 0xfc00, 0xf000, 0xc000, 0x0000, 0x0000, 0x0000}};

#ifdef TI92PLUS
  int groovy1handle = 0;
  BYTE groovy1[] = {
  #include "..\gfx\groovy92_1.h"
  };
  int groovy2handle = 0;
  BYTE groovy2[] = {
  #include "..\gfx\groovy92_2.h"
  };
#endif
#ifdef TI89
  int groovy1handle = 0;
  BYTE groovy1[] = {
  #include "..\gfx\groovy89_1.h"
  };
  int groovy2handle = 0;
  BYTE groovy2[] = {
  #include "..\gfx\groovy89_2.h"
  };
#endif

char TorusFileName[] = "\0torus";



WIN_RECT TestWinRect = {WIN_X,WIN_Y,WIN_X+WIN_WIDTH-1,WIN_Y+WIN_HEIGHT-1};
WIN_RECT TestWin2Rect = {WIN2_X,WIN2_Y,WIN2_X+WIN2_WIDTH-1,WIN2_Y+WIN2_HEIGHT-1};
char SPText1[]="Select a fruit:";
char TestWindowTitle[] = "Test";
char ButtonQuitText[] = "QUIT";

char TLI1[] = "Apple";
char TLI2[] = "Apricot";
char TLI3[] = "Banana";
char TLI4[] = "Blueberry";
char TLI5[] = "Cherry";
char TLI6[] = "Grape";
char TLI7[] = "Lemon";
char TLI8[] = "Orange";
char TLI9[] = "Pear";
char TLI10[] = "Pineapple";
char TLI11[] = "Raspberry";
char TLI12[] = "Strawberry";
char *TestListItems[12] = {TLI1, TLI2, TLI3, TLI4, TLI5, TLI6, TLI7, TLI8, TLI9, TLI10, TLI11, TLI12};

BEGIN_GUI_SECTION(aGuiSection)
  ADD_TEXT(PText1,0,{3,10,WIN_WIDTH-3-1,10+4},0,TEXT_LEFT_TOP+0,A_NORMAL,F_4x6,SPText1)
  ADD_LIST(TestList,8,{3,16,3+53-1,16+3+9*6-1},TRIG_CLICK+TRIG_REPEAT+TRIG_MOVE+1,SCROLLBAR_LEFT+ARROWS_SIDES, F_4x6,sizeof(TestListItems)/4,0,-1,TestListItems)
END_GUI_SECTION(aGuiSection)

BEGIN_GUI_SECTION(anotherGuiSection)
  ADD_TEXTBUTTON(ButtonQuit,-1,{0,0,WIN2_WIDTH-1,WIN2_HEIGHT-1},TRIG_RELEASE,TEXT_CENTER_CENTER, A_NORMAL,F_4x6,ButtonQuitText)
END_GUI_SECTION(anotherGuiSection)

WIN_RECT VerticalLine = {15,50,15,87}, HorizontalLine = {15,50,105,50};


// ************** Handlers ******************
void WindowHandler(EventClickStruct *e)
{
  if(e->action == GM_CLICK) {
    WM_Click(e);
  }
  else {
    switch(e->id) {
    case -1:
      Running = FALSE;
      break;
/*
    case 1:
      Button1.attr = A_NORMAL - Button1.attr;
      GM_DrawStructureObject(e->w, &Button1);
      PWinRefresh(e->w);
      break;
    case 2:
      PWinMoveToFront(e->w);
      break;
    case 3:
    case 4:
      InBetweenNumber += (e->id == 4)*(InBetweenNumber<99) -
                         (e->id == 3)*(InBetweenNumber>0);
      sprintf(InBetweenText, InBetweenTextStruct, InBetweenNumber);
      GM_DrawStructureObject(e->w, &PMText);
      PWinRefresh(e->w);
      break;
    case 6:
      e->w->Win.DupScr = e->w->ContentsHandle[0];
      e->w->Win.CurAttr = A_XOR;
      WinLine(&e->w->Win,&VerticalLine);
      VerticalLine.x0 = VerticalLine.x1 = 15+TestScroller1.current;
      WinLine(&e->w->Win,&VerticalLine);
      PWinRefresh(e->w);
      break;
    case 7:
      e->w->Win.DupScr = e->w->ContentsHandle[0];
      e->w->Win.CurAttr = A_XOR;
      WinLine(&e->w->Win,&HorizontalLine);
      HorizontalLine.y0 = HorizontalLine.y1 = 50+TestScroller2.current;
      WinLine(&e->w->Win,&HorizontalLine);
      PWinRefresh(e->w);
      break;
*/
    }
  }
}


// ************* Prosit Header **************
BEGIN_PROSIT_HEADER(_prosit)
  DEFINE_PROSIT_VERSION(PROSIT_VERSION_NUMBER)
  DEFINE_PROSIT_FILETYPE(PROSIT_FILETYPE_PROGRAM)
  DEFINE_PROSIT_STACKSIZE(0)
  DEFINE_PROSIT_EVENTBUFFERSIZE(256)
END_PROSIT_HEADER

// ************* Function Implementations **************
void _main(void)
{
  WORD QuitMessage = EVENT_QUIT;
  HANDLE TorusHandle, TorusFileHandle;
  EventStruct Event;
  PWINDOW TestWindow, TestWindow2;
  Running = TRUE;

//  ToggleScheduler();
//  asm("l78: bra l78");
//  ToggleScheduler();

  InitWindowSystem(&MyMousePointer);
//  GM_InitializeWindow(&BackgroundWindow);

  asm("	move.l	%0,%%a2
	lea	groovy1,%%a0
	jsr	shrnklib__0000
	moveq	#0,%%d1
	move.l	%%a2,%%a0
	jsr	shrnklib__0002
	jsr	shrnklib__0001" : : "a" ((void *)HeapDeref(BackgroundWindow.ContentsHandle[1])+4) : "a0", "a2", "d0", "d1", "d2");
  asm("	move.l	%0,%%a2
	lea	groovy2,%%a0
	jsr	shrnklib__0000
	moveq	#0,%%d1
	move.l	%%a2,%%a0
	jsr	shrnklib__0002
	jsr	shrnklib__0001" : : "a" ((void *)HeapDeref(BackgroundWindow.ContentsHandle[0])+4) : "a0", "a2", "d0", "d1", "d2");

  PWinRefresh(&BackgroundWindow);

  ListInitialize(&TestWindow.StructureList,FIFOListType);
  ListInsert(&TestWindow.StructureList, &aGuiSection);
  TestWindow.Win.Flags.all = WIN_FLAGS;
  TestWindow.header.flags = 0;
  TestWindow.header.priority = 0;
  PWinOpen(&TestWindow, &TestWinRect, TestWindowTitle, &WindowHandler);
  WM_InitializeWindow(&TestWindow);
  GM_InitializeWindow(&TestWindow);

/*
  TestWindow.Win.CurAttr = A_XOR;
  VerticalLine.x0 = VerticalLine.x1 = 15+TestScroller1.current;
  HorizontalLine.y0 = HorizontalLine.y1 = 50+TestScroller2.current;
  WinLine(&TestWindow.Win,&VerticalLine);
  WinLine(&TestWindow.Win,&HorizontalLine);
*/

  ListInitialize(&TestWindow2.StructureList,FIFOListType);
  ListInsert(&TestWindow2.StructureList, &anotherGuiSection);
  TestWindow2.Win.Flags.all = WIN2_FLAGS;
  TestWindow2.header.flags = 0;
  TestWindow2.header.priority = 120;
  PWinOpen(&TestWindow2, &TestWin2Rect, NULL, &WindowHandler);
  WM_InitializeWindow(&TestWindow2);
  GM_InitializeWindow(&TestWindow2);

  TorusFileHandle = ((SYM_ENTRY *)SymFindPtr((void *)TorusFileName+6,0))->handle;
  TorusHandle = NewProcess(TorusFileHandle);

  while(Running) {
//    Sleep(CurrentProcessID);
    ReadEvent(&Event);

    switch(Event.action) {
    case EVENT_CLICK_WINDOW:
      WM_Click((EventClickStruct *)&Event);
      break;
    case EVENT_CLICK_CLIENT:
      GM_Click((EventClickStruct *)&Event);
      break;
    }
  }

  TriggerEvent(TorusHandle, 2, &QuitMessage);

//  asm("l9: bra l9");

  while((RunningProcesses() + SleepingProcesses()) > 3)
    BreakAndCooperate();

  PWinClose(&TestWindow);
  PWinClose(&TestWindow2);
  CloseWindowSystem();
}
