/*******************
* HEADER FUNCTIONS *
*******************/
//
// Get a pointer to a file's _prosit header.
// Return NULL if file isn't a Prosit executable. 
//
void *GetPrositHeaderOfFile(HANDLE filehandle)
{
  PROSIT_FILE_HEADER *FileStart = (PROSIT_FILE_HEADER *)HeapDeref(filehandle);
  if((FileStart->signature == 0x36386b50) &&	// Signature = "68kP"
     (FileStart->rts == 0x4e75))		// First instruction is RTS
    return((void *)FileStart+FileStart->offset_prosit+2);
  else
    return(NULL);
}


// Get a pointer to a process' _prosit header.
// Return NULL if file isn't a Prosit executable. 
//
void *GetPrositHeaderOfProcess(HANDLE pid)
{
  void *header = (((PROCESS_CONTEXT_ENTRY *)HeapDeref(pid))->prositheader);
  if(header > 0)
    return(header);
  else
    return(NULL);
}

//
// Get a pointer to the next item in the _prosit header of <type>.
// Return NULL if no (more) such items exist.
//
void *FindPrositHeaderField(PrositHeaderElement_Header *current, WORD type)
{
  while(((current = (void *)current+current->parts.next)->fieldtype != type) &&
        (current->fieldtype != PROSIT_END_HEADER));
  if(current->fieldtype != PROSIT_END_HEADER)
    return(current);
  else
    return(NULL);
}
