/*----------------------------------------------------------------------------
   Torus Demo 1.1 - by Jimmy Mardell <mja@algonet.se>

    Fargo II conversion by David Ellsworth <davidell@earthling.net>
    92+ conversion by Kty
    Prosit conversion by Kty <kty@mailcity.com>
    Slightly modified by Prefect <e96nbr@efd.lth.se>
----------------------------------------------------------------------------*/

#define TI92PLUS
//#define TI89

#include <prosit.h>
#include <winlib.h>
#include <wmlib.h>
#include <gmlib.h>

#define WordWidth 14
#define nopoints 179
#define nolines nopoints*2

#define SQUARES_Y 14
#define STR_FLAGS_1 F_NORMAL
#define STR_FONT_1 0

#define WIN1_W 112
#define WIN1_H 100
#define WIN1_X LCD_WIDTH-WIN1_W
#define WIN1_Y 0
#define WIN1_W 112

#define TORUS_Y_START 10
#define TORUS_X_CENTER 66
#define TORUS_Y_CENTER 43

#define BUTTONS 8
#define BUT_W 12
#define BUT_W2 21
#define BUT_H 9
#define BUT_S BUT_H+1

enum DispModes {LINEMODE = 0, POINTMODE = 1};
enum ControlModes {AUTOMODE = 0, MANUALMODE = 1};

BYTE points[] = {
#include "T_POINTS.h"
};

BYTE lines[] = {
#include "T_LINES.h"
};

BYTE sintable[] = {
#include "SINT.h"
};

BYTE vx,vy,vz;
BYTE controlmode,dispmode;
WORD frames;
void *vscr;
ULONG dotc[nopoints+1];
PWINDOW MainWindow;




void DrawTorus(void)
{
  asm("		movem.l		%a0-%a6/%d0-%d7,-(%sp)
		move.l		vscr,%a0
		move.w		#87,%d0
	RepClr:
		and.l		#0xffffff00,(%a0)+
		clr.l		(%a0)+
		clr.l		(%a0)+
		and.w		#0x0001,(%a0)+
		dbra		%d0,RepClr

		move.l		vscr,%a0
		lea		dotc,%a1
		tst.b		dispmode
		bne		DrawPoints
		lea		lines,%a2
		move.l		#" XSTR(nolines) ",%d7

	RepDrawLines:
		clr.w		%d5
		clr.w		%d6
		move.b		(%a2)+,%d5	/* Point #1 */
		move.b		(%a2)+,%d6	/* Point #2 */
		lsl.w		#2,%d5
		lsl.w		#2,%d6
		move.w		0(%a1,%d5.w),%d0	/* X1 */
		move.w		2(%a1,%d5.w),%d1	/* Y1 */
		move.w		0(%a1,%d6.w),%d2	/* X2 */
		move.w		2(%a1,%d6.w),%d3	/* Y2 */
		bsr		Fline
	NextLine:
		dbra		%d7,RepDrawLines
		bra		DoneDrawing

	DrawPoints:
		move.l		#" XSTR(nopoints) ",%d7
	RepDrawPoints:
		move.w		(%a1)+,%d0	/* X */
		move.w		(%a1)+,%d4	/* Y */
		move.w		%d4,%d5
		lsl.w		#4,%d4		/* 5 */
		lsl.w		#1,%d5		/* 1 */
		sub.w		%d5,%d4
		move.w		%d0,%d5
		lsr.w		#3,%d5
		add.w		%d5,%d4
		move.w		%d0,%d5
		not		%d5
		and.b		#0x07,%d5
		bset.b		%d5,0(%a0,%d4.w)
		dbra		%d7,RepDrawPoints
	DoneDrawing:
		movem.l		(%sp)+,%a0-%a6/%d0-%d7");
}

// *******************************************************
// *Fast* line drawer.
// Thx to Jimmy Mardell
// *******************************************************

asm("	Fline:
		movem.l		%d0-%d7/%a0,-(%sp)
		cmp.w		%d0,%d2
		bcc		DXpos
		exg		%d0,%d2
		exg		%d1,%d3
	DXpos:
		move.w		%d1,%d4
		move.w		%d1,%d5
		lsl.w		#4,%d4		/* 5 */
		lsl.w		#1,%d5		/* 1 */
		sub.w		%d5,%d4
		move.w		%d0,%d5
		lsr.w		#3,%d5
		add.w		%d5,%d4
		move.w		%d0,%d5
		not		%d5
		and.b		#0x07,%d5
		adda		%d4,%a0
		bset.b		%d5,(%a0)
		move.b		%d5,%d6
		moveq		#1,%d5
		lsl		%d6,%d5
		move.w		%d2,%d6
		sub.w		%d0,%d6
	ChY:
		cmp.w		%d1,%d3
		bcc		DYpos
		moveq		#" XSTR(-WordWidth) ",%d4
		move.w		%d1,%d7
		sub.w		%d3,%d7
		bra		PutP1
	DYpos:
		moveq		#" XSTR(WordWidth) ",%d4
		move.w		%d3,%d7
		sub.w		%d1,%d7
	PutP1:					/* %d4 = YAI, %d5 = bit, %d6 = DX, %d7 = DY, %a0 = Ptr */
		cmp.w		%d0,%d2
		bne		DotsNE
		cmp.w		%d1,%d3
		beq		LineDone
	DotsNE:
		cmp.w		%d6,%d7
		bcc		DY_Greater
		move.l		%d6,%d2
		subq		#1,%d2		/* %d2 = number of pixels to be plot */
		move.w		%d7,%d3
		sub.w		%d6,%d3		/* %d3 = dy-dx */
		asl.w		#1,%d3		/* %d3 = ai */
		lsl.w		#1,%d7		/* %d7 = bi */
		sub.w		%d7,%d6
		neg		%d6		/* %d6 = d */
	RepX:
		or.w		%d6,%d6
		bmi		X_DNeg
		adda		%d4,%a0
		add.w		%d3,%d6
		bra		IncX
	X_DNeg:
		add.w		%d7,%d6
	IncX:
		ror.b		#1,%d5
		bcc		X_SameByte
		addq		#1,%a0
	X_SameByte:
		or.b		%d5,(%a0)
		dbra		%d2,RepX
		bra		LineDone
	DY_Greater:
		move.l		%d7,%d3
		subq		#1,%d3		/* %d3 = number of pixels to be plot */
		move.w		%d6,%d2
		sub.w		%d7,%d2		/* %d2 = dx-dy */
		lsl.w		#1,%d2		/* %d2 = ai */
		lsl.w		#1,%d6		/* %d6 = bi */
		sub.w		%d6,%d7
		neg		%d7		/* %d7 = d */
	RepY:
		or.w		%d7,%d7
		bmi		Y_DNeg
		ror.b		#1,%d5
		bcc		Y_SameByte
		addq		#1,%a0
	Y_SameByte:
		add.w		%d2,%d7
		bra		IncY
	Y_DNeg:
		add.w		%d6,%d7
	IncY:
		adda		%d4,%a0
		or.b		%d5,(%a0)
		dbra		%d3,RepY
	LineDone:
		movem.l		(%sp)+,%d0-%d7/%a0
		rts");

void Calc3D(void)
{
  asm("		movem.l		%a0-%a6/%d0-%d7,-(%sp)
		lea		points,%a0
		lea		sintable+0x80,%a1
		lea		sintable,%a2
		lea		dotc,%a6
		move.l		#" XSTR(nopoints) ",%d7
	RepPoints:
		move.l		%d7,-(%sp)
		move.w		(%a0)+,%d0
		ext.l		%d0
		move.w		(%a0)+,%d1
		ext.l		%d1
		move.w		(%a0)+,%d2
		ext.l		%d2

		clr.l		%d3
		move.b		vy,%d3
		lsl		#1,%d3
		move.w		0(%a1,%d3.w),%d4	/* %d4=yc */
		move.w		0(%a2,%d3.w),%d5	/* %d5=ys */
		ext.l		%d4
		ext.l		%d5

		move.l		%d0,%d6
		muls		%d4,%d6		/* %d6=x*yc */
		move.l		%d2,%d7
		muls		%d5,%d7		/* %d7=ys*z */
		sub.l		%d7,%d6
		asr.l		#8,%d6
		asr.l		#4,%d6
		move.l		%d6,%a3		/* %a3=(yc*x-ys*z)/factor (xt) */
		move.l		%d0,%d6
		muls		%d5,%d6
		move.l		%d2,%d7
		muls		%d4,%d7
		add.l		%d6,%d7
		asr.l		#8,%d7
		asr.l		#4,%d7
		move.l		%d7,%a4		/* %a4=(ys*x+yc*z)/factor (zt) */

		clr.l		%d3
		move.b		vz,%d3
		lsl		#1,%d3
		move.w		0(%a1,%d3.w),%d4	/* %d4=zc */
		move.w		0(%a2,%d3.w),%d5	/* %d5=zs */

		move.l		%a3,%d6
		muls		%d4,%d6
		move.l		%d1,%d7
		muls		%d5,%d7
		add.l		%d6,%d7
		asr.l		#8,%d7
		asr.l		#4,%d7
		move.l		%d7,%d0		/* %d0=(zc*xt+zs*y) DIV faktor (x) */
		move.l		%d1,%d6
		muls		%d4,%d6
		move.l		%a3,%d7
		muls		%d5,%d7
		sub.l		%d7,%d6
		asr.l		#8,%d6
		asr.l		#4,%d6
		move.w		%d6,%a5		/* %a5=(zc*y-zs*xt) DIV faktor (yt) */

		clr.l		%d3
		move.b		vx,%d3
		lsl		#1,%d3
		move.w		0(%a1,%d3.w),%d4	/* %d4=xc */
		move.w		0(%a2,%d3.w),%d5	/* %d5=xs */

		move.l		%a4,%d6
		muls		%d4,%d6
		move.l		%a5,%d7
		muls		%d5,%d7
		sub.l		%d7,%d6
		asr.l		#8,%d6
		asr.l		#4,%d6
		move.l		%d6,%d2		/* %d2=(xc*zt-xs*yt) DIV faktor (z) */
		move.l		%a5,%d6
		muls		%d4,%d6
		move.l		%a4,%d7
		muls		%d5,%d7
		add.l		%d6,%d7
		asr.l		#8,%d7
		asr.l		#4,%d7
		move.l		%d7,%d1		/* %d1=(xs*zt+xc*yt) DIV faktor (y) */

		sub.w		#1024,%d2
		beq		DivZero
		lsl.l		#8,%d0
		lsl.l		#2,%d0
		move.l		%d0,%d4
		divs		%d2,%d4
		ext.l		%d4
		add.l		#" XSTR(TORUS_X_CENTER) ",%d4	/* Move X out to middle of window */
		lsl.l		#8,%d1
		lsl.l		#2,%d1
		move.l		%d1,%d5
		divs		%d2,%d5
		ext.l		%d5
		add.l		#" XSTR(TORUS_Y_CENTER) ",%d5	/* Move Y out to middle of window */
		bra		PutPoint
	DivZero:
		move.l		#" XSTR(TORUS_X_CENTER) ",%d4
		move.l		#" XSTR(TORUS_Y_CENTER) ",%d5
	PutPoint:
		move.w		%d4,(%a6)+	/* Finished X */
		move.w		%d5,(%a6)+	/* Finished Y */
		move.l		(%sp)+,%d7
		dbra		%d7,RepPoints

		movem.l		(%sp)+,%a0-%a6/%d0-%d7");
}

void IncFrame(void);


char AutoModeText[] = "Auto";
char ManualModeText[] = "Man";
char LineModeText[] = "Line";
char DotModeText[] = "Dot";
char UpArrowText[] = {19,0};
char DownArrowText[] = {20,0};
char XTextS[] = "X";
char YTextS[] = "Y";
char ZTextS[] = "Z";
BEGIN_GUI_SECTION(MainGuiSection)
  ADD_TEXTBUTTON(ButtonControlMode,1,{3,10,3+19,10+8},TRIG_RELEASE,TEXT_CENTER_CENTER,A_NORMAL,F_4x6,AutoModeText)
  ADD_TEXTBUTTON(ButtonDispMode,2,{3,20,3+19,20+8},TRIG_RELEASE,TEXT_CENTER_CENTER,A_NORMAL,F_4x6,LineModeText)
  ADD_TEXTBUTTON(ButtonXUp,3,{14,31,14+8,31+8},TRIG_CLICK+TRIG_REPEAT+0,TEXT_CENTER_CENTER,A_NORMAL,F_4x6,UpArrowText)
  ADD_TEXTBUTTON(ButtonXDown,4,{14,41,14+8,41+8},TRIG_CLICK+TRIG_REPEAT+0,TEXT_CENTER_CENTER,A_NORMAL,F_4x6,DownArrowText)
  ADD_TEXTBUTTON(ButtonYUp,5,{14,54,14+8,54+8},TRIG_CLICK+TRIG_REPEAT+0,TEXT_CENTER_CENTER,A_NORMAL,F_4x6,UpArrowText)
  ADD_TEXTBUTTON(ButtonYDown,6,{14,64,14+8,64+8},TRIG_CLICK+TRIG_REPEAT+0,TEXT_CENTER_CENTER,A_NORMAL,F_4x6,DownArrowText)
  ADD_TEXTBUTTON(ButtonZUp,7,{14,77,14+8,77+8},TRIG_CLICK+TRIG_REPEAT+0,TEXT_CENTER_CENTER,A_NORMAL,F_4x6,UpArrowText)
  ADD_TEXTBUTTON(ButtonZDown,8,{14,87,14+8,87+8},TRIG_CLICK+TRIG_REPEAT+0,TEXT_CENTER_CENTER,A_NORMAL,F_4x6,DownArrowText)
  ADD_TEXT(XText,0,{4,35,4+8,35+10},0,TEXT_CENTER_CENTER,A_NORMAL,F_8x10,XTextS)
  ADD_TEXT(YText,0,{4,58,4+8,58+10},0,TEXT_CENTER_CENTER,A_NORMAL,F_8x10,YTextS)
  ADD_TEXT(ZText,0,{4,81,4+8,81+10},0,TEXT_CENTER_CENTER,A_NORMAL,F_8x10,ZTextS)
END_GUI_SECTION(MainGuiSection)


// ************** Handlers ******************
void WindowHandler(EventClickStruct *e)
{
  if(e->action == GM_CLICK) {
    WM_Click(e);
  }
  else {
    switch(e->id) {
    case 1:
      if(controlmode ^= 1)
        ButtonControlMode.str = ManualModeText;
      else
        ButtonControlMode.str = AutoModeText;
      GM_DrawStructureObject(e->w, &ButtonControlMode);
      PWinRefresh(e->w);
      break;
    case 2:
      if(dispmode ^= 1)
        ButtonDispMode.str = DotModeText;
      else
        ButtonDispMode.str = LineModeText;
      GM_DrawStructureObject(e->w, &ButtonDispMode);
    case 3:
      vx++;
      break;
    case 4:
      vx--;
      break;
    case 5:
      vy++;
      break;
    case 6:
      vy--;
      break;
    case 7:
      vz++;
      break;
    case 8:
      vz--;
      break;
    }

    if(controlmode) {
      Calc3D();
      DrawTorus();
      PWinRefresh(e->w);
    }
  }
}



BEGIN_PROSIT_HEADER(TorusHeader)
  DEFINE_PROSIT_VERSION(PROSIT_VERSION_NUMBER)
  DEFINE_PROSIT_FILETYPE(PROSIT_FILETYPE_PROGRAM)
  DEFINE_PROSIT_STACKSIZE(1024)
  DEFINE_PROSIT_EVENTBUFFERSIZE(256)
END_PROSIT_HEADER

void TorusProcess(void)
{
  HANDLE parent;
  EventStruct Event;

  do {
    while(!PendingEvents()) {
      if(controlmode == AUTOMODE) {
        vx += 4;
        vy += 5;
        vz += 6;
        Calc3D();
        DrawTorus();
        PWinRefresh(&MainWindow);
      }
      BreakAndCooperate();
    }

    parent = ReadEvent(&Event);
  } while(Event.action != EVENT_QUIT);

  Event.action = EVENT_HAVE_QUIT;
  TriggerEvent(parent, 2, &Event);
}

WIN_RECT MainWindowRect = {WIN1_X,WIN1_Y,WIN1_X+WIN1_W-1,WIN1_Y+WIN1_H-1};
char MainWindowTitle[] = "Torus Demo";

BEGIN_PROSIT_HEADER(_prosit)
  DEFINE_PROSIT_VERSION(PROSIT_VERSION_NUMBER)
  DEFINE_PROSIT_FILETYPE(PROSIT_FILETYPE_PROGRAM)
  DEFINE_PROSIT_STACKSIZE(1024)
  DEFINE_PROSIT_EVENTBUFFERSIZE(256)
END_PROSIT_HEADER

void _main(void)
{
  BOOL Running = TRUE;
  HANDLE TorusProcessID;
  EventStruct Event;

  ListInitialize(&MainWindow.StructureList,FIFOListType);
  ListInsert(&MainWindow.StructureList, &MainGuiSection);
  MainWindow.Win.Flags.all = PWF_USES_GMLIB+PWF_USES_WMLIB+PWF_ACTIVE+PWF_MOVEABLE;
  MainWindow.header.flags = 0;
  MainWindow.header.priority = 0;
  PWinOpen(&MainWindow, &MainWindowRect, MainWindowTitle, &WindowHandler);
  WM_InitializeWindow(&MainWindow);
  GM_InitializeWindow(&MainWindow);

  frames = 0;
  vscr = (void *)HeapDeref(MainWindow.ContentsHandle[0]) + 4+TORUS_Y_START*WordWidth;
  vx = 0x19;
  vy = 0x20;
  vz = 0x22;
  dispmode = LINEMODE;
  controlmode = AUTOMODE;

  TorusProcessID = ForkProcess(&TorusHeader, &TorusProcess);

  while(Running) {
//    Sleep(CurrentProcessID);
    ReadEvent(&Event);

    switch(Event.action) {
    case EVENT_CLICK_WINDOW:
      WM_Click((EventClickStruct *)&Event);
      break;
    case EVENT_CLICK_CLIENT:
      GM_Click((EventClickStruct *)&Event);
      break;
    case EVENT_QUIT:
      Running = FALSE;
      break;
    }
  }

  Event.action = EVENT_QUIT;
  TriggerEvent(TorusProcessID, 2, &Event);

  do {
//    Sleep(CurrentProcessID);
    ReadEvent(&Event);
  } while(Event.action != EVENT_HAVE_QUIT);

  PWinClose(&MainWindow);
}
